package utils

import (
	"errors"
	"os"
	"path/filepath"
	"reflect"
	"strings"
)

// PathExists 文件目录是否存在
func PathExists(path string) (bool, error) {
	fi, err := os.Stat(path)
	if err == nil {
		if fi.IsDir() {
			return true, nil
		}
		return false, errors.New("存在同名文件")
	}
	if os.IsNotExist(err) {
		return false, nil
	}
	return false, err
}

// CreateDir 批量创建文件夹
func CreateDir(dirs ...string) error {
	for _, v := range dirs {
		exist, err := PathExists(v)
		if err != nil {
			return err
		}
		if !exist {
			if err := os.MkdirAll(v, os.ModePerm); err != nil {
				return err
			}
		}
	}
	return nil
}

// FileMove 文件移动
// src: 源位置，绝对路径或相对路径
// dst: 目标位置，绝对路径或相对路径，必须为文件夹
func FileMove(src string, dst string) error {
	if dst == "" {
		return nil
	}
	var err error
	src, err = filepath.Abs(src)
	if err != nil {
		return err
	}
	dst, err = filepath.Abs(dst)
	if err != nil {
		return err
	}

	dir := filepath.Dir(dst)
	if _, err = os.Stat(dir); err != nil {
		if err = os.MkdirAll(dir, 0o755); err != nil {
			return err
		}
	}
	return os.Rename(src, dst)
}

// DeLFile 删除文件或目录
func DeLFile(filePath string) error {
	return os.RemoveAll(filePath)
}

// TrimSpace 去除结构体字符串字段的空格
// target: 目标结构体，传入必须是指针类型
func TrimSpace(target interface{}) {
	t := reflect.TypeOf(target)
	if t.Kind() != reflect.Ptr {
		return
	}
	t = t.Elem()
	v := reflect.ValueOf(target).Elem()
	for i := 0; i < t.NumField(); i++ {
		if v.Field(i).Kind() == reflect.String {
			v.Field(i).SetString(strings.TrimSpace(v.Field(i).String()))
		}
	}
}

// FileExist 判断文件是否存在
func FileExist(path string) bool {
	fi, err := os.Lstat(path)
	if err == nil {
		return !fi.IsDir()
	}
	return !os.IsNotExist(err)
}

// DirExist 判断目录是否存在
func DirExist(path string) bool {
	fi, err := os.Stat(path)
	if err == nil {
		return fi.IsDir()
	}
	return false
}
